#! /bin/bash
#
version="V23.04.012";
# # wenn Script-Dateiname ".KDEtweaksManjaro.sh" und Ort /home/USER/bin/ ist, kann mit einem Dateimanager (z.B.Dolphin)
# eine "Verknüpfung zu Programm ..." erstellt werden (Kontextmenü -> Neu erstellen)
# Wichtig! Befehl: konsole -e ~/bin/KDEtweaksManjaro.sh
#
#
# Zugriffsrechte: alle /home/USER/ Dateien chmod 644 und Ordner chmod 755 geben (Ordner .gnupg chmod 700), wenn du das willst mit einer 1 aktivieren, sonst 0
# ACHTUNG! Wer Programme ohne sudo unter /home/USER/ installiert hat (z.B. Tor Browser oder ein Flatpak mit dem Flag --user), sollte das nicht tun
# *.sh und *.desktop und *.AppImage Dateien werden ausführbar gemacht - Dateien ohne diese Extension sind dann nicht ausführbar!
# z.B. ~/bin/master-pdf-editor5 ! Ab Version 5 kann diese Datei nicht umbenannt werden (es gibt einen Starter master-pdf-editor5.sh), daher muss diese Datei dann manuell auf ausführbar gesetzt werden!
#
zugriffsrechte=0;
#
#
# Flatpak ist eine Alternative zu Canonical snap Apps, wenn du das benutzt mit einer 1 aktivieren, sonst 0
flatpak=1;
#
#
#
#
# ab hier nur ändern wenn du weisst was du tust!
    # gibt es ein public_html im Homeordner?
    if [ -d ~/public_html ]; then
       html="1";
       else
       html="0";
    fi

    echo $version;


    ###################################################################################

    answer=`kdialog --radiolist "Bitte wähle:" 1 "System aktualisieren/aufräumen" on 2 "mit AUR aktualisieren/aufräumen" off \
    3 "Verwaiste Pakete löschen" off 4 "Alle Pakete im Cache löschen" off 5 "Spiegelserver D/F/Ö laden" off \
    6 "Zugriffsrechte aktualisieren" off 7 "System Infos" off 8 "Temperatursensoren" off 9 "NVMe SSD S.M.A.R.T. LOG" off 2>/dev/null`;

    case $answer in
        "1")
        #echo -e "\nSystemaktualisierung:\n" && sudo pacman -Syyuu && sudo paccache -rk2 && sudo pacman -Qdtq;
        echo -e "\nSystemaktualisierung:\n" && pamac upgrade && pamac clean --keep 2;

           if [ $flatpak -gt 0 ]
              then
              echo;
              echo "suche Flatpak unused + updates:";
              flatpak uninstall --unused && flatpak update;
              echo "Done";
           fi

        kdialog --msgbox "Systemaktualisierung fertig.\nBitte die Konsolenausgabe auf evtl. Fehler prüfen." 2>/dev/null;
        ;;
        "2")
        #echo -e "\nAUR Systemaktualisierung (benötigt das Paket YAY):\n" && yay -Syyuu && sudo paccache -rk2 && sudo pacman -Qdtq;
        echo -e "\nAUR Systemaktualisierung:\n" && pamac upgrade -a && pamac clean --keep 2;

           if [ $flatpak -gt 0 ]
              then
              echo;
              echo "suche Flatpak unused + updates:";
              flatpak uninstall --unused && flatpak update;
              echo "Done";
           fi

        kdialog --msgbox "AUR Systemaktualisierung fertig.\nBitte die Konsolenausgabe auf evtl. Fehler prüfen." 2>/dev/null;
        ;;
        "3")
        echo -e "\nVerwaiste Pakete löschen - nur wenn Ziel-Datei spezifiziert ist:\n" && sudo pacman -Rsn $(pacman -Qdtq);
        kdialog --msgbox "Verwaiste Pakete gelöscht - wenn Ziel-Datei spezifiziert war.\n(ansonsten kann Fehlermeldung ignoriert werden)" 2>/dev/null;
        ;;
        "4")
        echo -e "\nAlle Pakete im Cache vollständig entfernen:\n" && sudo pacman -Scc;
        kdialog --msgbox "Alle Pakete im Cache vollständig entfernt.\n(wenn mit J beantwortet)" 2>/dev/null;
        ;;
        "5")
        echo -e "\nSpiegelserver D/F/Ö laden:\n" && sudo pacman-mirrors --country Germany,France,Austria
        kdialog --msgbox "Spiegelserver D/F/Ö geladen.\nBitte die Konsolenausgabe auf evtl. Fehler prüfen." 2>/dev/null;
        ;;
        "6")
        # Besitzrechte und Zugriffsrechte rekursiv in /home/USER/ dem Benutzer geben
        echo -e "\nZugriffsrechte und Besitzer neu setzen:\n"
        echo "Liste dein /home/USER/";
        echo "";
        echo "Bitte warten...";

        # Besitzer: alle /home/USER/ Dateien dem aktuellen Benutzer geben
        sudo chown -R $USER:$USER ~/

            # Zugriffsrechte: alle /home/USER/ Dateien chmod 644 und Ordner chmod 755 geben (Ordner .gnupg chmod 700))
            if [ $zugriffsrechte -gt 0 ]
              then
              sudo find ~/ \( -type d -exec chmod 755 {} + \);
              sudo find ~/ \( -type f -exec chmod 644 {} + \);
              sudo find ~/.gnupg \( -type d -exec chmod 700 {} + \);
            fi
       

            # nur wenn es im home Ordner ein public_html gibt:
            case "$html" in
            0) echo ""; #dummy
            ;;
            1) # Besitzer: alle public_html Dateien der Gruppe und User http geben
               # nur aktivieren wenn ~/public_html benutzt wird!
               sudo chown -R http:http ~/public_html/;

               # Zugriffsrechte: alle public_html Dateien chmod 664 und Ordner chmod 775 geben
               # nur aktivieren wenn ~/public_html benutzt wird!
               sudo find ~/public_html/ \( -type d -exec chmod 775 {} + \);
               sudo find ~/public_html/ \( -type f -exec chmod 664 {} + \);
            ;;
            *) echo "error html";;
            esac


            # *.sh und *.desktop und *.AppImage ausführbar machen
            sudo find ~/ -name "*.sh" -exec chmod 0744 {} \;
            sudo find ~/ -name "*.desktop" -exec chmod 0744 {} \;
            sudo find ~/ -name "*.AppImage" -exec chmod 0744 {} \;
                        
        clear;

        # Im home Ordner sollten sich keine Dateien befinden die nicht dem Benutzer gehören!
        # Ausnahme: Wenn das Apache Modul mod_userdir und ~/public_html benutzt wird, gehören diese Dateien der Gruppe http.

        # Liste Dateien die nicht dem Benutzer oder http gehören!
        find ~ ! -user $USER -and ! -user http -ls;
        echo "";
        echo "##################################################################################";
        echo "";

            case "$html" in
            0) echo "*** hier sollte nichts stehen und alle Dateien gehören dir ***";
               echo "";
               echo "Hinweis: alle deine *.sh und *.desktop und *.AppImage Dateien im Homeordner sind ausführbar!";
            ;;
            1) echo "*** hier sollte nichts stehen und alle Dateien - ausser im Ordner ~/public_html - gehören dir ***";
               echo "*** Dateien im Ordner ~/public_html gehören dem User http und chmod ist 664 bzw. 775 ***";
               echo "";
               echo "Hinweis: alle deine *.sh und *.desktop und *.AppImage Dateien im Homeordner sind ausführbar!";
            ;;
            *) echo "error2";;
            esac

        echo "";
        echo "##################################################################################";
        echo "";
        kdialog --msgbox "Zugriffsrechte und Besitzer neu gesetzt.\nBitte die Konsolenausgabe auf evtl. Fehler prüfen." 2>/dev/null;
        ;;
        "7")
        echo -e "\nSystem Infos:\n" && lsb_release -a && inxi -Fz;
        kdialog --msgbox "System Infos" 2>/dev/null;
        ;;
        "8")
        echo -e "\nTemperatursensoren:\n" && sensors;
        kdialog --msgbox "Temperatursensoren" 2>/dev/null;
        ;;
        "9")
        #wenn nicht installiert: sudo pacman -S nvme-cli
        #reset;
        echo -e "\nNVMe SSD DEVICE S.M.A.R.T. LOG:\n" && sudo nvme --smart-log /dev/nvme0n1;
        kdialog --msgbox "NVMe SSD DEVICE S.M.A.R.T. LOG" 2>/dev/null;
        ;;
        *) echo "abgebrochen";;
    esac

exit;
